ECHO OFF
CLS
rem     This BAT file provides an example use of the configuration/
rem     installation utility LLCONFIG.COM.
rem
rem           Title: Fixed data path, User specied name
rem     Description: Runs LLCONFIG.COM with a DOS parameter for data
rem                  file naming. Can be used to configure a group
rem                  of workstations to write data to the same path
rem                  whilst retaining individual data file names.

rem     check to see user has provided a data file name

if "%1"=="" goto error

rem     they have provided a file name perform installation

:INST

ECHO    ͻ
ECHO         INSTALLING & CONFIGURING LANLOG's TSR LLOG.COM   
ECHO    ͹
ECHO                                                          
ECHO           Installation will take only a few seconds.     
ECHO                                                          
ECHO     NOTE: Previously installed copies of LLOG.COM will   
ECHO           be erased - press CNTRL-C to terminate         
ECHO           installation, any other key to continue.       
ECHO                                                          
ECHO       {Cntrl-C} = terminate, any other key = continue    
ECHO                                                          
ECHO    ͼ

rem     get user response

PAUSE

rem     Run the LLCONFIG.COM file

LLCONFIG /PATH: C:\METER /NAME: %1

rem     To change the destination drive and path edit C:\METER
rem     Note, this will create a Meter file only installation
rem     use the /LOG and /MET command line options to override
rem     this default

goto QUIT

:ERROR

rem     user didn't provide a command line parameter for created data
rem     file name.

CLS

ECHO    ͻ
ECHO                         SYNTAX ERROR                     
ECHO    ͹
ECHO                                                          
ECHO     This BATCH file requires a name with which to create 
ECHO     LANLOG's monitor data file(s).                       
ECHO                                                          
ECHO     The correct syntax:                                  
ECHO                                                          
ECHO                   CONFEG02 {name}                        
ECHO                                                          
ECHO     where {name} is any DOS valid 8 character string.    
ECHO                                                          
ECHO     Example:                                             
ECHO                                                          
ECHO                   CONFEG02 GEORGE                        
ECHO                                                          
ECHO                                                          
ECHO    ͼ

rem     The End

:QUIT

ECHO ON
