ECHO OFF
CLS
rem     This BAT file provides an example use of the configuration/
rem     installation utility LLCONFIG.COM.
rem
rem           Title: Use physical LAN address, provide department name.
rem     Description: Runs LLCONFIG.COM with a DOS parameter for data
rem                  path selection. Uses /netware command line option
rem                  for file naming. The data path selected may
rem                  represent the department of the workstation etc


rem     NOTE:   THIS BATCH FILE ASSUMES THAT THE WORKSTATION ON WHICH IT
rem             IS RUN IS RUNNING NOVELL NETWARE

rem     check to see user has provided a dept/dir name

if "%1"=="" goto error

rem     they have provided a file name perform installation

:INST

ECHO    ͻ
ECHO         INSTALLING & CONFIGURING LANLOG's TSR LLOG.COM   
ECHO    ͹
ECHO                                                          
ECHO           Installation will take only a few seconds.     
ECHO                                                          
ECHO     NOTE: Previously installed copies of LLOG.COM will   
ECHO           be erased - press CNTRL-C to terminate         
ECHO           installation, any other key to continue.       
ECHO                                                          
ECHO       {Cntrl-C} = terminate, any other key = continue    
ECHO                                                          
ECHO    ͼ

rem     get user response

PAUSE

rem     Run the LLCONFIG.COM file

LLCONFIG /PATH: C:\METER.DAT\%1 /NETWARE

rem     To change the destination drive and path edit C:\METER.DAT
rem     Note, this will create a Meter file only installation
rem     use the /LOG and /MET command line options to override
rem     this default.

rem     If you wish to use physical address but are not running netware
rem     you can replace /NETWARE with /NETBIOS - netbios need only be
rem     running for the installation, -NOT- during the normal operation
rem     of the workstation.

rem     Including either /Netware or /Netbios will have unpredicatble
rem     results if these systems are not in fact loaded

goto QUIT

:ERROR

rem     user didn't provide a command line parameter for created data
rem     file name.

CLS

ECHO    ͻ
ECHO                         SYNTAX ERROR                     
ECHO    ͹
ECHO                                                          
ECHO     This BATCH file requires a name with which to create 
ECHO     a portion of LANLOG's data file destination path.    
ECHO                                                          
ECHO     The correct syntax:                                  
ECHO                                                          
ECHO                   CONFEG03 {name}                        
ECHO                                                          
ECHO     where {name} is any DOS valid 12 character string.   
ECHO                                                          
ECHO     Example:                                             
ECHO                                                          
ECHO                   CONFEG03 ACCOUNTS                      
ECHO                                                          
ECHO    ͼ

rem     The End

:QUIT

ECHO ON
