ECHO OFF
CLS
rem     This BAT file provides an example use of LANLOG's report
rem     generation utility LLREPORT.COM.
rem
rem           Title: Produce Meter file and Totalled report to files
rem     Description: Runs LLREPORT.COM with a DOS parameter for meter
rem                  file report and one for total file report.

rem     check to see user has provided a meter file report file
rem     name.

if "%1"=="" goto error

rem     check to see user has provided a total file report file
rem     name.

if "%2"=="" goto error

rem     they have provided file names perform reporting

:START

ECHO    ͻ
ECHO         REPORTING METER DATA AND TOTALED DATA TO FILE    
ECHO    ͹
ECHO                                                          
ECHO     This BATCH file produces two files, the first        
ECHO     contains a report of all meter files in the current  
ECHO     directory, the second a totaled report across all    
ECHO     those meter files.                                   
ECHO                                                          
ECHO    ͼ

rem     check for a total file delete if neccessary.

if exist LANLOG.TOT goto DELTOT

:REPT

rem     Run the LLREPORT.COM to produce first report and LANLOG.TOT

ECHO .
ECHO .  Generating a report of all meter files to file:
ECHO .
ECHO .                  %1
ECHO .
ECHO .  Please be patient.....

LLREPORT *.MET /TOT > %1

rem     Note: this command presumes a copy of LLREPORT is present
rem     in the current directory or that it can be found in your PATH

rem     Produce a report of the created totals file.

ECHO .
ECHO .  Generating a totaled report for all meter files to file:
ECHO .
ECHO .                  %2
ECHO .
ECHO .  Please be patient.....

LLREPORT LANLOG.TOT > %2

goto QUIT

:DELTOT

del LANLOG.TOT > nul

goto REPT

:ERROR

rem     user didn't provide a command line parameter for created data
rem     file name.

CLS

ECHO    ͻ
ECHO                         SYNTAX ERROR                     
ECHO    ͹
ECHO                                                          
ECHO     This BATCH file expects two parameters, the first is 
ECHO     a file name for the meter file report, the second a  
ECHO     file name for the LANLOG.TOT file report.            
ECHO                                                          
ECHO     The correct syntax:                                  
ECHO                                                          
ECHO                   REPTEG03 {name1} {name2}               
ECHO                                                          
ECHO     where {nameX} are any valid DOS path.                
ECHO                                                          
ECHO     Example:                                             
ECHO                                                          
ECHO               REPTEG03 ACCOUNTS.IND ACCOUNTS.ALL         
ECHO                                                          
ECHO    ͼ

rem     The End

:QUIT

ECHO ON
