@echo off
REM
REM ZIPALL1T.BAT
REM
REM This BAT file can be executed from within any subdirectory to cause PKZIP
REM to implode every file in the current directory BUT NOT IN ITS CHILD
REM DIRECTORIES (if any) into a single file called ALLFILES.ZIP.  All the ori-
REM ginal files are copied into the ZIP file, the affected directory retaining
REM the original files.  Hidden and system files are zipped also.
REM Attributes for Hidden, Read-only and System files are retained. 
REM Use the "-Jhrs" switch when unzipping with PKUNZIP.EXE or just use 
REM UNZIPALL.BAT if the file is on a machine containing the batch file.
REM If you want to MOVE all affected files into ALLFILES.ZIP, use ZIPALL1.BAT
REM instead.
REM
if not exist allfiles.zip goto continue
cls
dir /w
echo.
echo This subdirectory already contains an ALLFILES.ZIP.  Delete it, or rename
echo it if you really want it to be contained within the new ALLFILES.ZIP.
goto exit
:continue
pkzip allfiles *.* -ex -whs -Jhrs
if errorlevel 1 goto errexit
dir
echo ALLFILES.ZIP has been successfully created and original files retained.
echo Use PKUNZIP.EXE with the "-Jhrs" switch to unzip -- this is necessary 
echo to retain file attributes of Hidden, Read-only and System files.
echo If you convert this .ZIP file to a .EXE using ZIP2EXE.EXE, you must remember
echo to use the same "-Jhrs" switch when the self-extracting ALLFILES.EXE  
echo is executed (ie:  "ALLFILES -Jhrs").
goto exit
:errexit
echo Error in execution of PKZIP (via ZIPALL1T.BAT).
:exit
echo on
