@echo off
REM
REM ZIPALLT.BAT
REM
REM This BAT file can be executed from within any subdirectory to cause PKZIP
REM to implode every file in the current directory and every file in its child
REM directories (if any) into a single file called ALLFILES.ZIP.  All the ori-
REM ginal files are copied into the ZIP file, the affected directories retaining
REM the original files.  Hidden and system files are zipped also.
REM Attributes for Hidden, Read-only and System files are retained. 
REM Use the "-d -Jhrs" switches when unzipping with PKUNZIP.EXE or just use 
REM UNZIPALL.BAT if the file is on a machine containing the batch file.
REM If you want to MOVE all affected files into ALLFILES.ZIP, use ZIPALL.BAT
REM instead.
REM
if not exist allfiles.zip goto continue
cls
dir /w
echo.
echo This subdirectory already contains an ALLFILES.ZIP.  Delete it, or rename it
echo if you really want to keep it within the new ALLFILES.ZIP.
goto exit
:continue
pkzip allfiles *.* -ex -rp -whs -Jhrs
if errorlevel 1 goto errexit
dir
echo ALLFILES.ZIP has been successfully created and original files retained.
echo Use PKUNZIP.EXE with the "-d -Jhrs" switches to unzip -- this is necessary 
echo to retain file attributes of Hidden, Read-only and System files and 
echo to build child subdirectories, if necessary.  If you convert this .ZIP
echo file to a .EXE using ZIP2EXE.EXE, you must remember to use the same  
echo "-d -Jhrs" switches when the self-extracting ALLFILES.EXE is executed.
goto exit
:errexit
echo Error in execution of PKZIP (via ZIPALLT.BAT).
:exit
echo on
