@echo off
REM
REM ZIPEX.BAT
REM
REM This BAT file can be executed from within any subdirectory to cause PKZIP
REM to implode every file in the current directory and every file in its child
REM directories (if any) into a single file called ALLFILES.EXE.  All the ori-
REM ginal files are copied into the EXE file, the affected directories retain
REM the original files.  Hidden, System, and Read-only files are zipped also.
REM ALLFILES.EXE is a self-extracting file.  Executing the following command
REM will explode its contents:  "ALLFILES -d -Jhrs".  It is advisable to 
REM allways use the "-d -Jhrs" switches when unzipping .ZIP or .EXE files, in
REM case there are subdirectories to be built or file attributes to retain.
REM
if not exist allfiles.zip goto continue
cls
dir /w
echo .
echo This subdirectory already contains an ALLFILES.ZIP.  Delete it, or rename
echo it if you really want it to be within the new ALLFILES.EXE.
goto exit
:continue
pkzip allfiles *.* -ex -rp -whs -Jhrs
if errorlevel 1 goto errexit
zip2exe allfiles.zip
if errorlevel 1 goto errexit2
del allfiles.zip
dir
echo.
echo ALLFILES.EXE has been successfully created and orignial files retained.
echo ALLFILES.EXE is a self-extracting file.  Executing the following command
echo will explode its contents:  "ALLFILES -d -Jhrs".  It is advisable to 
echo allways use the "-d -Jhrs" switches when unzipping .ZIP or .EXE files, in
echo case there are subdirectories to be built or file attributes to retain.
goto exit
:errexit
echo Error in execution of PKZIP (via ZIPEX.BAT).
goto exit
:errexit2
echo Error in execution of ZIP2EXE (via ZIPEX.BAT).
:exit
echo on
